#include "Executable.h"
#include "stringops.h"

#include "process.h"

Executable::Executable(char *path)
{
	Arguments = 0;
	Count = 0;
	AddArgument(path);
}

Executable::~Executable(void)
{
	unsigned int i;

	if (Arguments) {
		for (i=0;i<Count;i++) delete[] Arguments[i];
		delete[] Arguments;
	}
}

void Executable::AddArgument(const char *arg)
{
	unsigned int i;
	char **newargs;

	newargs = new char *[Count+2];	// allocate one more for NULL termination
	if (Arguments) {
		for (i=0;i<Count;i++) newargs[i] = Arguments[i];
	}
	newargs[Count] = copystring(arg);
	newargs[Count+1] = 0;			// NULL termination
	delete[] Arguments;
	Arguments = newargs;
	Count++;
}

void Executable::AddArgument(SP<StringStream> arg)
{
	AddArgument(arg->GetString());
}

void Executable::Spawn(bool wait)
{
	int mode;

	if (wait) mode = _P_WAIT;
	else mode = _P_NOWAIT;
	_spawnvp(mode, Arguments[0], Arguments);
}
